using namespace std;

//fill all emlements in a 2 by 2 contingency table, no need to clear before or after
//actually 3 by 3 including sums
//Y is phenotype and X is SNP
//10 means #(Y=1 and X=0)
void fill_2_2_table(const biPhenotype& Y, const biSNP& X, float ctable[3][3])
{
	int sup1_=Y.count(); 
	int sup_1=X.count();


	Intermedia temp11(MAX_NUM_OF_INDIVIDUALS);
	temp11 |= Y; temp11 &= X;

	int sup11 = temp11.count();

	int sup10 = sup1_ - sup11;
	
	int sup01 = sup_1 - sup11;

	int sup00 = TOTAL_NUMBER_OF_INDIVIDUALS - sup11 - sup10 - sup01;


	ctable[0][0] = sup00;
	ctable[0][1] = sup01;
	ctable[0][2] = sup00 + sup01;

	ctable[1][0] = sup10;
	ctable[1][1] = sup11;
	ctable[1][2] = sup10 + sup11;

	ctable[2][0] = sup00 + sup10;
	ctable[2][1] = sup01 + sup11;

	//total number can be omitted
	ctable[2][2] = TOTAL_NUMBER_OF_INDIVIDUALS;

}


//fill all emlements in a 2 by 4 contingency table, no need to clear before or after
//actually 3 by 5 including sums
//Y is phenotype, X1 and X2 are SNPs
//101 means #(Y=1 and X1=0 and X2=1)
void fill_2_4_table(const biPhenotype& Y, const biSNP& X1, const biSNP& X2, float ctable[3][5])
{
	int sup1__=Y.count(); 
	int sup_1_=X1.count();
	int sup__1=X2.count();


	Intermedia temp11_(MAX_NUM_OF_INDIVIDUALS);
	temp11_ |= Y; temp11_ &= X1; 

    Intermedia temp111(MAX_NUM_OF_INDIVIDUALS);
	temp111 |= temp11_; temp111 &= X2;
	
	int sup111 = temp111.count();
	int sup110 = temp11_.count() - sup111;


	Intermedia temp00_(MAX_NUM_OF_INDIVIDUALS);
	temp00_ |= Y; temp00_ |= X1; 

	int sup00_ = TOTAL_NUMBER_OF_INDIVIDUALS - temp00_.count();

	Intermedia temp000(MAX_NUM_OF_INDIVIDUALS);
	temp000 |= temp00_; temp000 |= X2;

	int sup000 = TOTAL_NUMBER_OF_INDIVIDUALS - temp000.count();
	int sup001 = sup00_ - sup000;

	Intermedia temp_11(MAX_NUM_OF_INDIVIDUALS);
	temp_11 |= X1; temp_11 &= X2; 

	int sup_11 = temp_11.count();

	int sup011 = sup_11 - sup111;
	int sup010 = TOTAL_NUMBER_OF_INDIVIDUALS - sup1__ - sup000 - sup001 - sup011;

	Intermedia temp_00(MAX_NUM_OF_INDIVIDUALS);
	temp_00 |= X1; temp_00 |= X2;
	
	int sup_00 = TOTAL_NUMBER_OF_INDIVIDUALS -temp_00.count();

	int sup100 = sup_00 - sup000;
	int sup101 = sup1__ - sup100 - sup110 - sup111;


	ctable[0][0] = sup000;
	ctable[0][1] = sup001;
	ctable[0][2] = sup010;
	ctable[0][3] = sup011;

	ctable[1][0] = sup100;
	ctable[1][1] = sup101;
	ctable[1][2] = sup110;
	ctable[1][3] = sup111;

	ctable[0][4] = TOTAL_NUMBER_OF_INDIVIDUALS - sup1__;
	ctable[1][4] = sup1__;

	ctable[2][0] = sup000 + sup100;
	ctable[2][1] = sup001 + sup101;
	ctable[2][2] = sup010 + sup110;
	ctable[2][3] = sup011 + sup111;



	//total number can be omitted
	ctable[2][4] = TOTAL_NUMBER_OF_INDIVIDUALS;



}




