using namespace std;


//get the chi-score for a input contingency table,
//the input table is fully filled, including the sums
//if there exists an expected value equal to 0, than return 0;
float get_chi_score(const float ctable[NUMBER_OF_ROWS+1][NUMBER_OF_COLUMNS+1])
{
	float score=0; 
	
	float expected_value=0;
	float deviation=0;

	for (int i=0;i<NUMBER_OF_ROWS;i++)
	{
		for (int j=0;j<NUMBER_OF_COLUMNS;j++)
		{
			expected_value = (ctable[i][NUMBER_OF_COLUMNS] * ctable[NUMBER_OF_ROWS][j]) / TOTAL_NUMBER_OF_INDIVIDUALS;

			//check if any expected value is less than 1
			if (expected_value == 0) 
			{
//				score = score + 1;
			}

			else			
			{
				deviation = ctable[i][j] - expected_value;

				score = score + ((deviation*deviation) / expected_value);
			}
		}
	}

	return score;
}

//get chi-score for 2 by 2, actually 3 by 3 including sums
float get_chi_score_2_2(const float ctable[3][3])
{
	float score=0; 
	
	float expected_value=0;
	float deviation=0;

	for (int i=0;i<2;i++)
	{
		for (int j=0;j<2;j++)
		{
			expected_value = (ctable[i][2] * ctable[2][j]) / TOTAL_NUMBER_OF_INDIVIDUALS;

			//check if any expected value is less than 1
			//check if any expected value is less than 1
			if (expected_value == 0) 
			{
//				score = score + 1;
			}

			else			
			{
				deviation = ctable[i][j] - expected_value;

				score = score + ((deviation*deviation) / expected_value);
			}
		}
	}

	return score;
}


//get chi-score for 2 by 4, actually 3 by 5 including sums
float get_chi_score_2_4(const float ctable[3][5])
{
	float score=0; 
	
	float expected_value=0;
	float deviation=0;

	for (int i=0;i<2;i++)
	{
		for (int j=0;j<4;j++)
		{
			expected_value = (ctable[i][4] * ctable[2][j]) / TOTAL_NUMBER_OF_INDIVIDUALS;

			//check if any expected value is less than 1
			//check if any expected value is less than 1
			if (expected_value == 0) 
			{
//				score = score + 1;
			}

			else			
			{
				deviation = ctable[i][j] - expected_value;

				score = score + ((deviation*deviation) / expected_value);
			}
		}
	}

	return score;
}





//calculate all (two-locus & phenotype) chi-square statistics (using X)
void standard_two_locus_chi_test_all(const biPhenotype& Y, const vector<biSNP>& X)
{
	vector<biSNP>::const_iterator iter1, iter2;

	float ctable[3][5];

	for (iter1=X.begin();iter1!=X.end();iter1++)
	{
		iter2=iter1;
		iter2++;

		for (;iter2!=X.end();iter2++)
		{
			fill_2_4_table(Y, (*iter1), (*iter2), ctable);

			output_2_4_table(ctable);

			cout<<get_chi_score_2_4(ctable)<<endl<<endl;

		}
		
	}

}

//calculate all (two-locus & phenotype) chi-square statistics (using directX)
void standard_two_locus_chi_test_all(const biPhenotype& Y, const biSNP directX[])
{
	vector<biSNP>::const_iterator iter1, iter2;

	float ctable[3][5];

	for (int i=0;i<NUMBER_OF_SNPs;i++)
	{

		for (int j=i+1;j<NUMBER_OF_SNPs;j++)
		{
			fill_2_4_table(Y, directX[i], directX[j], ctable);

			output_2_4_table(ctable);

			cout<<get_chi_score_2_4(ctable)<<endl<<endl;

		}
		
	}

}



