using namespace std;

////////////////////////////////functions about reading in and accessing the ordered array list/////////////////
float max ( const float & a, const float & b ) 
{
  return (b<a)?a:b;
}

float min ( const float & a, const float & b ) 
{
  return (b>a)?a:b;
}


/*
void get_R1_R2(const bitset<TOTAL_NUMBER_OF_INDIVIDUALS>& Xi, const bitset<TOTAL_NUMBER_OF_INDIVIDUALS>& Xj, float& R1, float& R2)
{
	float sup1_=Xi.count(); 
	float sup_1=Xj.count();


	bitset<TOTAL_NUMBER_OF_INDIVIDUALS> temp11;
	temp11 |= Xi; temp11 &= Xj;

	float sup11 = temp11.count();

	float sup10 = sup1_ - sup11;
	
	float sup01 = sup_1 - sup11;

	float sup00 = TOTAL_NUMBER_OF_INDIVIDUALS - sup11 - sup10 - sup01;

	if (sup00==0||sup01==0) 
	{
		R1=0;
	}
	else	R1 = min (sup01/sup00, sup00/sup01);



	if (sup10==0||sup11==0) 
	{
		R2=0;
	}
	else	R2 = min (sup11/sup10, sup10/sup11);

}
*/


void get_P_Q(const biSNP& Xi, const biSNP& Xj, float& p, float& q)
{   
	float sup1_=Xi.count(); 
	float sup_1=Xj.count();


	Intermedia temp11(MAX_NUM_OF_INDIVIDUALS);
	temp11 |= Xi; temp11 &= Xj;

	q = temp11.count();

	p = sup_1 - q;

}


//update r1list
void update_r1list(R1list& r1list, const float& r2, const int& jid)
{
	list<R2list>::iterator iter;

	R2list tempr2list;

	iter=r1list.r2list.begin();

	//find the right position
	while ((iter!=r1list.r2list.end()) && (r2 < (*iter).r2))  
	{
		iter++;
	}

	//if r2 is less than all the r2 value in the r2list, or the r2list is empty, then directly push back
	if (iter==r1list.r2list.end()) 
	{
		tempr2list.r2=r2;
		tempr2list.jlist.push_back(jid);

		r1list.r2list.push_back(tempr2list);
	}
	
	else
	{
		//if r2 already exists in the r2list, then push back j in the corresponding r2list
		if (r2==(*iter).r2) 
		{
			(*iter).jlist.push_back(jid);

		}

		//else insert a new r2list using r2 and jid
		else 
		{
			tempr2list.r2=r2;
			tempr2list.jlist.push_back(jid);

			r1list.r2list.insert(iter, tempr2list);

		}

	}

}

//for a SNP Xi, update its list of r1lists
void update_list_of_r1list(list<R1list>& listofr1list, const float& r1, const float& r2, const int&jid)
{
	list<R1list>::iterator iter;

	R1list tempr1list;

	iter=listofr1list.begin();

	//find the right position
	while ((iter!=listofr1list.end()) && (r1 < (*iter).r1) )
	{
		iter++;
	}

	//if r1 is less than all the r1 value in the listofr1list, or the listofr1list is empty, then directly push back
	if (iter==listofr1list.end()) 
	{
		tempr1list.r1=r1;
		update_r1list(tempr1list, r2, jid);

		listofr1list.push_back(tempr1list);
	}

	else
	{
		//if r1 already exists in the listofr1list, then update the corresponding r1list
		if (r1==(*iter).r1)
		{
			update_r1list(*iter, r2, jid);
		}

		//else insert a new r1list using r1, r2 and jid
		else 
		{
			tempr1list.r1=r1;
			update_r1list(tempr1list, r2, jid);

			listofr1list.insert(iter, tempr1list);
			
		}

	}


}



float get_upperbound(float chi_score_YXi, float T1, float T2, float OA, float OB, float OC, float OD, float OP, float OQ, float SuppXi)
{
	float b1part1=0; float b1part2=0; float b2part1=0; float b2part2=0;


	float lc2 = max (0, OP-OA);
	float uc2 = min (OP, OC);		
	float ld2 = max (0, OQ-OB);
	float ud2 = min (OQ, OD);


	float OS = (TOTAL_NUMBER_OF_INDIVIDUALS - SuppXi) - OP;
	float OT = SuppXi - OQ;


	if ((OS==0)||(OP==0)) 
	{
		b1part1=0; b2part1=0;
	}
	else 
	{
		b1part1 = ((T1/(OS*OP))*((OA+OC)*lc2 -(OC*OP))*((OA+OC)*lc2 -(OC*OP)));
		b2part1 = ((T1/(OS*OP))*((OA+OC)*uc2 -(OC*OP))*((OA+OC)*uc2 -(OC*OP)));
	}


	if ((OT==0)||(OQ==0)) 
	{
		b1part2=0; b2part2=0;
	}
	else 
	{
		b1part2 = ((T2/(OT*OQ))*((OB+OD)*ld2 - OD*OQ)*((OB+OD)*ld2 - OD*OQ));
		b2part2 = ((T2/(OT*OQ))*((OB+OD)*ud2 - OD*OQ)*((OB+OD)*ud2 - OD*OQ));
	}


	return chi_score_YXi + max(b1part1, b2part1) + max(b1part2, b2part2);

}



//get the SNP ids (Xj's) from a list of R1list of the SNP Xi
//candidate list is cleared within the procedure
void access_list_of_r1list(const list<R1list>& listofr1list, const float chiscoreXiY, const float T1, float T2, float OA, float OB, float OC, float OD, float SuppXi, const float theta, list<int>& candidates)
{
	candidates.clear();

	list<R1list>::const_iterator iter1;
	list<R2list>::const_iterator iter2;

	list<int>::const_iterator iter3;

	int j=0;

	for (iter1=listofr1list.begin();iter1!=listofr1list.end();iter1++)
	{
		for (iter2=(*iter1).r2list.begin();iter2!=(*iter1).r2list.end();iter2++)
		{
			if (get_upperbound(chiscoreXiY, T1, T2, OA, OB, OC, OD, (*iter1).r1, (*iter2).r2, SuppXi) >= theta) 
			{
				for (iter3=(*iter2).jlist.begin();iter3!=(*iter2).jlist.end();iter3++)
				{

					j=*iter3;
					candidates.push_back(j);

				}

			}
/*			else
			{
				break;//since listofr1list is ordered, so break out if r2 is small enough
			}

*/		}
	}

}


int r1r2list_size(const list<R1list>& listofr1list)
{
	int listsize =0;

	list<R1list>::const_iterator iter1;
	list<R2list>::const_iterator iter2;

	for (iter1=listofr1list.begin();iter1!=listofr1list.end();iter1++)
	{
		for (iter2=(*iter1).r2list.begin();iter2!=(*iter1).r2list.end();iter2++)
		{
			listsize++;
		}
	}

	return listsize;

}


//calculate chi_scores for all Xi and their corresponding Xj's
float chi_square_by_accessing_list_of_r1list(const vector<biSNP>& X,  const biSNP directX[])
{


	//generate Ylist for permutation
	//biPhenotype Ylist[PERMUTATION];
	biPhenotype *Ylist;
	Ylist=new biPhenotype[PERMUTATION];

	int r;
	set<int> rnumbers;

	set<int>::const_iterator iter;

	srand(1);//( (unsigned)time( NULL ) );
    
	int p;
    
	for (p=0;p<PERMUTATION;p++)
	{
        Ylist[p].resize(MAX_NUM_OF_INDIVIDUALS);        
		rnumbers.clear();
        
		while (rnumbers.size()!=(NUMBER_OF_CASES)) 
		{
			r = rand();
			r= r - (TOTAL_NUMBER_OF_INDIVIDUALS*(r/TOTAL_NUMBER_OF_INDIVIDUALS));

//			cout<<r<<endl;
			rnumbers.insert(r);
		}

//		cout<<endl;
		//overwrite Y
		Ylist[p].reset();

		for(iter=rnumbers.begin();iter!=rnumbers.end();iter++)
		{
			Ylist[p].set(*iter);

		}

//		cout<<endl;

	}

    
	///////////////permutation start/////////////////////////
	clock_t start_time = clock();

	clock_t time_read_in_listofr1list = clock();
	clock_t time_access_listofr1list = clock();
	clock_t time_chi_square_computing = clock();
	clock_t time_updating_topk_list = clock();


	__int64 visited=0;////////////////////////////

//	int pruncount=0;////////////////////////////

	int i=0, j=0;

	list<TwoLocus> topk_list;

	list<R1list> listofr1list;
	 
	float theta=0; //an important factor, always keeps the min chi_score in the topk list

	float ctable_2_2[3][3], ctable_2_4[3][5];

	float T1,  T2;

	float chi_score_YXi;



	vector<biSNP>::const_iterator iter1, iter2;


	list<int> tempcandidatelist;

	list<int>::const_iterator iter3;
    
	for (iter1=X.begin();iter1!=X.end();iter1++)
	{
		if (i%(MAX_NUM_OF_SNPS/100)==0) 
		{
			cout <<"@@" <<i*100/MAX_NUM_OF_SNPS <<endl; //Send out progress percentages.

			//cout<<theta<<endl;
		}

//		cout<<i<<endl;

		//////////generate the list of r1list on the fly///////////////

		clock_t time1 = clock();

		float r1, r2;

		iter2=iter1;
		iter2++;

        if (iter2==X.end()) continue;
        
		listofr1list.clear();

		int k=i+1;

		for(;iter2!=X.end();iter2++)
		{
//            cout <<"hi" <<endl;
            
			get_P_Q((*iter1), (*iter2), r1, r2);

//            cout <<"hi2" <<endl;            
			update_list_of_r1list(listofr1list, r1, r2, k);

			k++;
		}
//        cout <<"hi3?" <<endl;
        

//		cout<<r1r2list_size(listofr1list);

//		getchar();

//		getin_listofr1r2list(listofr1list);

		
		time1 = clock()-time1;
		time_read_in_listofr1list = time_read_in_listofr1list + time1;


		for (p=0;p<PERMUTATION;p++)
		{

			float suppY=Ylist[p].count();



			fill_2_2_table(Ylist[p], (*iter1), ctable_2_2);

	//		output_2_2_table(ctable_2_2);

			chi_score_YXi = get_chi_score_2_2(ctable_2_2);

			float suppXi=(*iter1).count();

			T1 = (TOTAL_NUMBER_OF_INDIVIDUALS * TOTAL_NUMBER_OF_INDIVIDUALS) / ((TOTAL_NUMBER_OF_INDIVIDUALS-suppY)*(TOTAL_NUMBER_OF_INDIVIDUALS-suppXi)*(suppY));

			T2 = (TOTAL_NUMBER_OF_INDIVIDUALS * TOTAL_NUMBER_OF_INDIVIDUALS) / ((TOTAL_NUMBER_OF_INDIVIDUALS-suppY)*(suppXi)*(suppY));


			clock_t time2 = clock();


			access_list_of_r1list(listofr1list, chi_score_YXi, T1, T2, ctable_2_2[0][0], ctable_2_2[0][1], ctable_2_2[1][0], ctable_2_2[1][1], suppXi, theta, tempcandidatelist);

			visited = visited + tempcandidatelist.size();

			time2 = clock()-time2;
			time_access_listofr1list = time_access_listofr1list + time2;


			clock_t time3 = clock();
			for (iter3=tempcandidatelist.begin();iter3!=tempcandidatelist.end();iter3++)
			{


				j=*iter3;

				fill_2_4_table(Ylist[p], directX[i], directX[j], ctable_2_4);

				TwoLocus tempelem;

				tempelem.phenotype_id = p;///////////////////////////

				tempelem.Xi_id=i;
				tempelem.Xj_id=j;
                tempelem.Xi_genotype.resize(MAX_NUM_OF_INDIVIDUALS);                
				tempelem.Xi_genotype.reset();
				tempelem.Xi_genotype |= directX[i];
                tempelem.Xj_genotype.resize(MAX_NUM_OF_INDIVIDUALS);
				tempelem.Xj_genotype.reset();
				tempelem.Xj_genotype |= directX[j];
				tempelem.chi_score = get_chi_score_2_4(ctable_2_4);


				clock_t time4 = clock();


				update_topk_list_pid(topk_list, tempelem, theta);

				if (topk_list.size()!=0) 
				{
					theta = min_chi_score_in_the_topk_list(topk_list);

				}


				time4 = clock() - time4;

				time_updating_topk_list = time_updating_topk_list + time4;

	//			output_topklist(topk_list);

		
				//set theta accordingly
	//			if (topk_list.size()==TOPK) 
				{
	//				theta=topk_list.back().chi_score;

				}
	//			else theta=0;
					

			}
			time3 = clock()-time3;
			time_chi_square_computing = time_chi_square_computing + time3;




		}

		i++;
			
	}

    

    
    //cout <<endl <<"=========== top k permutation test values =========" <<endl;
//	for (p=0;p<PERMUTATION;p++)
	//{

//		dataout<<"phenotype: "<<Ylist[p]<<endl;

	//	topk_list.sort();
	//	output_topklist(topk_list, Ylist);
	//}

//	dataout<<"pruncount: "<<pruncount<<endl;

//	cout<<"listofr1list generating in time: "<<((double)(time_read_in_listofr1list-start_time))/ CLOCKS_PER_SEC<<"  seconds"<<endl;
//	cout<<"listofr1list access time: "<<((double)(time_access_listofr1list-start_time))/ CLOCKS_PER_SEC<<"  seconds"<<endl;
//	cout<<"chi-square computing time (including topk list updating time): "<<((double)(time_chi_square_computing-start_time))/ CLOCKS_PER_SEC <<" ("<<((double)(time_updating_topk_list-start_time))/ CLOCKS_PER_SEC<<")"<<" seconds"<<endl;
//	cout<<"topk list updating time:: "<<((double)(time_updating_topk_list-start_time))/ CLOCKS_PER_SEC<<"  seconds"<<endl;
	

	char buf[20], buf1[20], buf2[20], buf3[20];
    sprintf(buf,"%lld", visited);
//	cout<<"total visited: "<<buf<<endl;

	__int64 ave_visited=visited/PERMUTATION;////////////////////////////
    sprintf(buf1,"%lld", ave_visited);
//	cout<<"average visited per permuation: "<<buf1<<endl;

	__int64 total_nodes_each_permuation = (((__int64)(NUMBER_OF_SNPs))*((__int64)(NUMBER_OF_SNPs-1)))/2;////////////////////////////
    sprintf(buf2,"%lld", total_nodes_each_permuation);
//	cout<<"total nodes per permuation: "<<buf2<<endl;

	__int64 pruned_nodes_each_permuation = total_nodes_each_permuation - ave_visited;////////////////////////////
    sprintf(buf3,"%lld", pruned_nodes_each_permuation);
//	cout<<"pruned nodes per permuation: "<<buf3<<endl;

	float ratio = (pruned_nodes_each_permuation*1.0)/(total_nodes_each_permuation);
	cout<<endl;
	cout<<"Pruning ratio: "<<ratio<<endl;
	cout<<"Threshold:" <<theta<<endl;
    cout<<"Runtime: "<<((double)clock() - start_time)/ CLOCKS_PER_SEC<<"  seconds"<<endl;
	cout<<"----------------------"<<endl;

    //cout <<"==========================================" <<endl;
    return theta;
}

//calculate chi_scores for all Xi and their corresponding Xj's
void chi_square_original_pheno(const vector<biSNP>& X,  const biSNP directX[], const biPhenotype Y, float theta)
{    
	///////////////permutation start/////////////////////////
	clock_t start_time = clock();

	clock_t time_read_in_listofr1list = clock();
	clock_t time_access_listofr1list = clock();
	clock_t time_chi_square_computing = clock();
	clock_t time_updating_topk_list = clock();


	__int64 visited=0;////////////////////////////

//	int pruncount=0;////////////////////////////

	int i=0, j=0;

	list<TwoLocus> topk_list;

	list<R1list> listofr1list;
	 
	//float theta=0; //an important factor, always keeps the min chi_score in the topk list

	float ctable_2_2[3][3], ctable_2_4[3][5];

	float T1,  T2;

	float chi_score_YXi;
    
	vector<biSNP>::const_iterator iter1, iter2;


	list<int> tempcandidatelist;

	list<int>::const_iterator iter3;

    cout <<endl <<"------- significant SNP-pairs -------" <<endl;
	for (iter1=X.begin();iter1!=X.end();iter1++)
	{
		//if (i%(MAX_NUM_OF_SNPS/100)==0) 
		//{
			//cout <<"@@" <<i*100/MAX_NUM_OF_SNPS <<endl; //Send out progress percentages.

			//cout<<theta<<endl;
		//}

        //cout<<i<<endl;

		//////////generate the list of r1list on the fly///////////////

		clock_t time1 = clock();

		float r1, r2;

		iter2=iter1;
		iter2++;

        if (iter2==X.end()) continue;
        
		listofr1list.clear();

		int k=i+1;

		for(;iter2!=X.end();iter2++)
		{
//            cout <<"hi" <<endl;
            
			get_P_Q((*iter1), (*iter2), r1, r2);

//            cout <<"hi2" <<endl;            
			update_list_of_r1list(listofr1list, r1, r2, k);

			k++;
		}
//        cout <<"hi3?" <<endl;
        

//		cout<<r1r2list_size(listofr1list);

//		getchar();

//		getin_listofr1r2list(listofr1list);

		
		time1 = clock()-time1;
		time_read_in_listofr1list = time_read_in_listofr1list + time1;


//		for (p=0;p<PERMUTATION;p++)
//		{

        float suppY=Y.count();



        fill_2_2_table(Y, (*iter1), ctable_2_2);

        //output_2_2_table(ctable_2_2);

        chi_score_YXi = get_chi_score_2_2(ctable_2_2);

        float suppXi=(*iter1).count();

        T1 = (TOTAL_NUMBER_OF_INDIVIDUALS * TOTAL_NUMBER_OF_INDIVIDUALS) / ((TOTAL_NUMBER_OF_INDIVIDUALS-suppY)*(TOTAL_NUMBER_OF_INDIVIDUALS-suppXi)*(suppY));

        T2 = (TOTAL_NUMBER_OF_INDIVIDUALS * TOTAL_NUMBER_OF_INDIVIDUALS) / ((TOTAL_NUMBER_OF_INDIVIDUALS-suppY)*(suppXi)*(suppY));


        clock_t time2 = clock();


        access_list_of_r1list(listofr1list, chi_score_YXi, T1, T2, ctable_2_2[0][0], ctable_2_2[0][1], ctable_2_2[1][0], ctable_2_2[1][1], suppXi, theta, tempcandidatelist);

        visited = visited + tempcandidatelist.size();

        time2 = clock()-time2;
        time_access_listofr1list = time_access_listofr1list + time2;


        clock_t time3 = clock();
        for (iter3=tempcandidatelist.begin();iter3!=tempcandidatelist.end();iter3++)
        {
            j=*iter3;

            fill_2_4_table(Y, directX[i], directX[j], ctable_2_4);

            TwoLocus tempelem;

            tempelem.phenotype_id = 0;///////////////////////////

            tempelem.Xi_id=i;
            tempelem.Xj_id=j;
            tempelem.Xi_genotype.resize(MAX_NUM_OF_INDIVIDUALS);                
            tempelem.Xi_genotype.reset();
            tempelem.Xi_genotype |= directX[i];
            tempelem.Xj_genotype.resize(MAX_NUM_OF_INDIVIDUALS);
            tempelem.Xj_genotype.reset();
            tempelem.Xj_genotype |= directX[j];
            tempelem.chi_score = get_chi_score_2_4(ctable_2_4);


            clock_t time4 = clock();
/*            
            update_topk_list_pid(topk_list, tempelem, theta);

            if (topk_list.size()!=0) 
            {
                theta = min_chi_score_in_the_topk_list(topk_list);

            }
*/
            if (tempelem.chi_score>=theta){
                //cout<<"phenotype id: "<<0 <<endl;
                //cout<<"phenotype : "<<endl <<Y <<endl;
                cout<<"X"<<tempelem.Xi_id<<endl;
                cout<<tempelem.Xi_genotype<<endl;
                cout<<"X"<<tempelem.Xj_id<<endl;
                cout<<tempelem.Xj_genotype<<endl;

                //fill_2_4_table(Y, tempelem.Xi_genotype, tempelem.Xj_genotype, ctable_2_4);
                //output_2_4_table(ctable_2_4);

                cout<<"chi_score: "<<tempelem.chi_score<<endl;
                cout<<"---------"<<endl;
            }
            
                
            time4 = clock() - time4;

            time_updating_topk_list = time_updating_topk_list + time4;

            //			output_topklist(topk_list);

		
            //set theta accordingly
            //			if (topk_list.size()==TOPK) 
            {
                //				theta=topk_list.back().chi_score;

            }
            //			else theta=0;
					

        }
        time3 = clock()-time3;
        time_chi_square_computing = time_chi_square_computing + time3;

        i++;
			
    }
    
    cout <<"----------------------------" <<endl;
//	for (p=0;p<PERMUTATION;p++)
//	{
//		dataout<<"phenotype: "<<Ylist[p]<<endl;
//		topk_list.sort();
//		output_topklist(topk_list, Ylist);
//	}

//	dataout<<"pruncount: "<<pruncount<<endl;

//	cout<<"listofr1list generating in time: "<<((double)(time_read_in_listofr1list-start_time))/ CLOCKS_PER_SEC<<"  seconds"<<endl;
//	cout<<"listofr1list access time: "<<((double)(time_access_listofr1list-start_time))/ CLOCKS_PER_SEC<<"  seconds"<<endl;
//	cout<<"chi-square computing time (including topk list updating time): "<<((double)(time_chi_square_computing-start_time))/ CLOCKS_PER_SEC <<" ("<<((double)(time_updating_topk_list-start_time))/ CLOCKS_PER_SEC<<")"<<" seconds"<<endl;
//	cout<<"topk list updating time:: "<<((double)(time_updating_topk_list-start_time))/ CLOCKS_PER_SEC<<"  seconds"<<endl;
    
//cout<<"Run time: "<<((double)clock() - start_time)/ CLOCKS_PER_SEC<<"  seconds"<<endl;
//cout<<"----------------------"<<endl;

//char buf[20], buf1[20], buf2[20], buf3[20];
//sprintf(buf,"%lld", visited);
//	cout<<"total visited: "<<buf<<endl;

//__int64 ave_visited=visited/PERMUTATION;////////////////////////////
//sprintf(buf1,"%lld", ave_visited);
//	cout<<"average visited per permuation: "<<buf1<<endl;

//__int64 total_nodes_each_permuation = (((__int64)(NUMBER_OF_SNPs))*((__int64)(NUMBER_OF_SNPs-1)))/2;////////////////////////////
//sprintf(buf2,"%lld", total_nodes_each_permuation);
//	cout<<"total nodes per permuation: "<<buf2<<endl;

//__int64 pruned_nodes_each_permuation = total_nodes_each_permuation - ave_visited;////////////////////////////
//sprintf(buf3,"%lld", pruned_nodes_each_permuation);
//	cout<<"pruned nodes per permuation: "<<buf3<<endl;

//float ratio = (pruned_nodes_each_permuation*1.0)/(total_nodes_each_permuation);
//cout<<"pruning ratio: "<<ratio<<endl;

//cout<<theta<<endl;

}
