#include <stdafx.h>
#include <iostream>
#include <fstream>
#include <list>
#include <stack>
#include <vector>
#include <string>
#include <bitset>
#include <set>
#include <time.h>
#include <algorithm>
#include <sstream>

#include <cmath>

#include "1_global.h"
#include "2_inputoutputfuncs.h"
#include "3_contingencytable.h"
#include "4_standard_chi.h"
#include "5_listfuncs.h"
#include "7_r1r2list.h"
#include "8_tests.h"

#include "../common/global.hpp"

#define verbose 1

using namespace std;

int MAX_NUM_OF_INDIVIDUALS;
int MAX_NUM_OF_SNPS;
int NUM_OF_PERMUTATIONS;

void test()

{

//	clock_t start_time = clock();

/*	list<R1list> listofr1list;

	list<int> candidates;


	for (int i=0;i<NUMBER_OF_SNPs;i++)
	{
		getin_listofr1r2list(listofr1list);
//		output_listofr1list(listofr1list);

		access_list_of_r1list(listofr1list, 5.06745, 50.0489, 55.1789, 55, candidates);
		output_intlist(candidates);

		getin_listofr1r2list(listofr1list);
		access_list_of_r1list(listofr1list, 0.56305, 36.1603, 40.5396, 55, candidates);
		output_intlist(candidates);

		getin_listofr1r2list(listofr1list);
		access_list_of_r1list(listofr1list, 0.56305, 40.5396, 36.1603, 55, candidates);
		output_intlist(candidates);
d		
		getin_listofr1r2list(listofr1list);
		access_list_of_r1list(listofr1list, 0.0625611, 32.0313, 36.1603, 55, candidates);
		output_intlist(candidates);
		cout<<"done";
		getchar();

	}
*/	
//	pruning_effect();

	//bitset<TOTAL_NUMBER_OF_INDIVIDUALS> Y;
    biPhenotype Y;    
	vector<biSNP> X;
    float theta;
    
	getin_data(Y, X);
    
	theta=chi_square_by_accessing_list_of_r1list(X, directX);
    chi_square_original_pheno(X,directX,Y,theta);



//	cout<<get_upperbound(11.2208, 0.190476, 0.363636, 6, 10, 15, 1, 3, 1, 11);


//	standard_two_locus_chi_test_all_output_bound(Y,X);

/*	list<R1R2sublist> lrr;

	generate_R1R2_list(X,lrr);
	output_allSNPs_r1r2_list(lrr);

	list<individualrrarray> rrarraylist;

	generate_R1R2_array_list(lrr, rrarraylist);

//	output_arraysize_rrarraylist(rrarraylist);

//	output_rrarraylist(rrarraylist);



	chi_by_indexed_prune(Y, X, rrarraylist, directX);
*/
/*	list<R1R2arrayelements> rrarray;

	list<R1R2sublist>::const_iterator iter1=lrr.begin();

	iter1++;

	create_R1R2_array(1, (*iter1).sublist, rrarray);

	output_rrarray(rrarray);
*/
//	list<int> candlist;
//	access_R1R2_array(rrarray, 0.190416, 85.4555, 53.7766, 35, candlist);

//	output_intlist(candlist);

//	cout<<candlist.size();


//	cout<<Y<<endl<<endl;

//	getchar();

//	output_SNPlist(X);
//	cout<<endl;
	
//	output_SNPlist(X);

//	cout<<endl;

//	output_SNPlist(directX);

//	cout<<endl;

//	count_pruned_node(Y,X);

//	getchar();

/*
	bitset<TOTAL_NUMBER_OF_INDIVIDUALS> X1( (long) 127 );
	bitset<TOTAL_NUMBER_OF_INDIVIDUALS> X2( (long) 102 );


	float ctable[3][3];

	fill_2_2_table(X1, X2, ctable);

	output_2_2_table(ctable);

	float R1, R2;

	cout<<X1<<endl;
	cout<<X2<<endl;


	get_R1_R2(X1, X2, R1, R2);

	cout<<R1<<"  "<<R2<<endl;

*/


/*	list<TwoLocus> topk_list;

	TwoLocus e1, e2, e3, e4;

	e1.chi_score=0.4;
	e2.chi_score=0.6;
	e3.chi_score=0.8;
	e4.chi_score=0.1;

	update_topk_list(topk_list, e1);
	output_topklist(topk_list);
	cout<<endl;
	update_topk_list(topk_list, e2);
	output_topklist(topk_list);
	cout<<endl;
	update_topk_list(topk_list, e3);
	output_topklist(topk_list);
	cout<<endl;
	update_topk_list(topk_list, e4);
	output_topklist(topk_list);
	cout<<endl;
*/
/*

*/


//	standard_two_locus_chi_test_all(Y, X);
	
//	standard_two_locus_chi_test_all(Y, directX);



//	float ctable[3][5]={3, 6, 9, 16, 34, 4, 20, 19, 10, 53, 7, 26, 28, 26, TOTAL_NUMBER_OF_INDIVIDUALS};
//	cout<<get_chi_score_2_4(ctable)<<endl;

/*
	bitset<TOTAL_NUMBER_OF_INDIVIDUALS> Y( (long) 1023 );
	bitset<TOTAL_NUMBER_OF_INDIVIDUALS> X1( (long) 127 );
	bitset<TOTAL_NUMBER_OF_INDIVIDUALS> X2( (long) 399 );
	cout<<"Y : "<<Y<<endl;
	cout<<"X1: "<<X1<<endl;
	cout<<"X2: "<<X2<<endl;

	float ctable[3][5];
	fill_2_4_table(Y, X1, X2, ctable);
	output_2_4_table(ctable);
*/



//	cout<<"Running time: "<<((double)clock() - start_time)/ CLOCKS_PER_SEC<<"  seconds"<<endl;

}


//**********MAIN***********
//*************************

int main(int argc, char * argv[])
{
    if (argc<7) {
        cerr <<"Error: Not enough parameters!" <<endl;
        cerr <<"Usage: " <<argv[0] <<" geno_fn pheno_fn #individuals #SNPs #permutations fwer_threshold" <<endl;        
        return 1;
    }
    
    string INPUTFILE_1(argv[1]);
    geno_infile.open(INPUTFILE_1.c_str());
    if (geno_infile.fail()){
        cerr <<"Error: Cannot open "+INPUTFILE_1+" to read!" <<endl;
        exit(1);                
    };

    string INPUTFILE_2(argv[2]);
    pheno_infile.open(INPUTFILE_2.c_str());
    if (pheno_infile.fail()){
        cerr <<"Error: Cannot open "+INPUTFILE_2+" to read!" <<endl;
        return 1;        
    };

    
    MAX_NUM_OF_INDIVIDUALS=atoi(argv[3]);
    MAX_NUM_OF_SNPS=atoi(argv[4]);
    NUM_OF_PERMUTATIONS=atoi(argv[5]);
    float fwer_threshold=atof(argv[6]);
    TOPK=int(floor(fwer_threshold*NUM_OF_PERMUTATIONS));
    
    
    TOTAL_NUMBER_OF_INDIVIDUALS=MAX_NUM_OF_INDIVIDUALS;
    NUMBER_OF_SNPs=MAX_NUM_OF_SNPS;
    PERMUTATION = NUM_OF_PERMUTATIONS;
    
	test();

	return 0;
}


